Name:           p4lang-bmv2
Version:        1.15.0
Release:        1%{?dist}
Summary:        P4 Behavioral Model version 2
License:        Apache-2.0
URL:            https://github.com/p4lang/behavioral-model
Source0:        https://github.com/p4lang/behavioral-model/archive/%{version}/behavioral-model-%{version}.tar.gz
Patch0:         https://github.com/p4lang/behavioral-model/commit/7a8843ffb87bab9eb0a44c993ae39a9fefca10cf.patch
Patch1:         https://github.com/p4lang/behavioral-model/commit/199af48e04ea8747f8296bdc51c2ce16bb96cb04.patch
Patch2:         behavioral-model-1.15.0-cstdint.patch
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  gcc-c++
BuildRequires:  boost-devel
BuildRequires:  gmp-devel
BuildRequires:  grpc-devel
BuildRequires:  grpc-plugins
BuildRequires:  libevent-devel
BuildRequires:  libpcap-devel
BuildRequires:  nanomsg-devel
BuildRequires:  thrift-devel
BuildRequires:  p4lang-pi-devel
BuildRequires:  protobuf-devel
BuildRequires:  python3-devel
BuildRequires:  python3-thrift
Requires:       python3-thrift

%description
BMv2 is a software switch that implements the P4 programmable data plane.

%package libs
Summary:        Shared libraries for p4lang-bmv2

%description libs
Shared libraries for the BMv2 software switch, used by applications that depend on BMv2 functionality.

%package devel
Summary:        Development files for p4lang-bmv2
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description devel
Development files for the BMv2 software switch, including headers and libraries for building applications that use BMv2.

%prep
%autosetup -p1 -n behavioral-model-%{version}

%build
autoreconf -if
autoreconf -if targets/simple_switch_grpc

%configure --disable-static --with-pdfixed --with-pi --enable-debugger
%make_build

cd targets/simple_switch_grpc
%configure --disable-static --with-thrift
%make_build

%install
%make_install
%make_install -C targets/simple_switch_grpc

find %{buildroot} -type f -name "*.la" -delete -print

%check
make check

%files
%doc README.md
%license LICENSE
%{_bindir}/bm_CLI
%{_bindir}/bm_nanomsg_events
%{_bindir}/bm_p4dbg
%{_bindir}/psa_switch
%{_bindir}/psa_switch_CLI
%{_bindir}/simple_switch
%{_bindir}/simple_switch_CLI
%{_bindir}/simple_switch_grpc
%{python3_sitelib}/*

%files libs
%{_libdir}/libbm_grpc_dataplane.so.*
%{_libdir}/libbmall.so.*
%{_libdir}/libbmp4apps.so.*
%{_libdir}/libbmpdfixed.so.*
%{_libdir}/libbmpdfixedthrift.so.*
%{_libdir}/libbmpi.so.*
%{_libdir}/libpsaswitch_thrift.so.*
%{_libdir}/libruntimestubs.so.*
%{_libdir}/libsimpleswitch_runner.so.*
%{_libdir}/libsimpleswitch_thrift.so.*

%files devel
%{_includedir}/bm
%{_includedir}/p4
%{_libdir}/libbm_grpc_dataplane.so
%{_libdir}/libbmall.so
%{_libdir}/libbmp4apps.so
%{_libdir}/libbmpdfixed.so
%{_libdir}/libbmpdfixedthrift.so
%{_libdir}/libbmpi.so
%{_libdir}/libpsaswitch_thrift.so
%{_libdir}/libruntimestubs.so
%{_libdir}/libsimpleswitch_runner.so
%{_libdir}/libsimpleswitch_thrift.so

%changelog
